package com.coolimagingproject.basicImageProcessingOperations.operadorAplicacion.operadoresTratamientoImagenes;

import com.coolimagingproject.coolimaging.libreriaimagenes.operador.publico.ConjuntoParametroOperador;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;

import com.coolimagingproject.basicImageProcessingOperations.operador.panelesOperadores.PanelInfoOperadorRotacion;
import com.coolimagingproject.basicImageProcessingOperations.operador.tratamientoImagenes.OperadorRotacion;
import com.coolimagingproject.coolimaging.controlador.operador.publico.ConjuntoInformacionImagenOperador;
import com.coolimagingproject.coolimaging.controlador.operador.publico.IOperadorAplicacion;
import com.coolimagingproject.coolimaging.controlador.operador.publico.InfoOperadorAplicacion;
import com.coolimagingproject.coolimaging.controlador.operador.publico.InformacionImagenOperador;
import com.coolimagingproject.coolimaging.vista.operador.panelesOperadores.publico.PanelInfoOperador;


/**
 * Operador que rota una imagen en un ngulo determinado.
 * 
 * @author L.A Gonzlez Jaime
 * @author R.J Palma Durn
 * 
 */
public class OperadorRotacionAplicacion implements IOperadorAplicacion{
	protected PanelInfoOperadorRotacion panelInfoOperador;
	protected OperadorRotacion operador;
	protected ConjuntoParametroOperador parametros;
	protected InfoOperadorAplicacion infoOperador;

	/**
	 * Constructor por defecto sin argumentos.
	 */
	public OperadorRotacionAplicacion(){
		crearInfoOperador();
	}

	/*
	 * (non-Javadoc)
	 * @see
	 * com.coolimagingproject.controlador.operador.IOperadorAplicacion#getPanelInfoOperador
	 * (org.eclipse.swt.widgets.Composite)
	 */
	public PanelInfoOperador getPanelInfoOperador(Composite parent){
		this.panelInfoOperador = new PanelInfoOperadorRotacion(parent, SWT.NONE);
		return this.panelInfoOperador;
	}

	/*
	 * (non-Javadoc)
	 * @see com.coolimagingproject.controlador.operador.IOperadorAplicacion#operar()
	 */
	public Object operar(){
		this.operador = new OperadorRotacion(this.parametros);
		return this.operador.operar();
	}

	/*
	 * (non-Javadoc)
	 * @see
	 * com.coolimagingproject.controlador.operador.IOperadorAplicacion#insertarParametros
	 * (operador.ConjuntoParametroOperador)
	 */
	public void insertarParametros(ConjuntoParametroOperador parametros){
		this.parametros = parametros;
	}
	
	/*
	 * (non-Javadoc)
	 * @see com.coolimagingproject.controlador.operador.IOperadorAplicacion#getTipoOperacion()
	 */
	public TipoIOperadorAplicacion getTipoOperacion(){
		return IOperadorAplicacion.TipoIOperadorAplicacion.OPERADOR_TRATAMIENTO_IMAGEN;
	}
	
	/*
	 * (non-Javadoc)
	 * @see
	 * com.coolimagingproject.controlador.operador.IOperadorAplicacion#getInfoOperador()
	 */
	public InfoOperadorAplicacion getInfoOperador(){
		return this.infoOperador;
	}
	
	/**
	 * Mtodo auxuliar que inicializa la variable this.infoOperador, creando el objeto
	 * InfoOperadorAplicaicon que contiene la informacin asociada a este IOperadorAplicacion.
	 */
	private void crearInfoOperador(){
		ConjuntoInformacionImagenOperador info = new ConjuntoInformacionImagenOperador();
		info.insertarInformacionImagen(new InformacionImagenOperador(
				"Imagen a rotar", OperadorRotacion.PARAMETRO_IMAGEN_FUENTE));
		this.infoOperador=new InfoOperadorAplicacion("Rotacin","Realiza la rotacin de una imagen un cierto grado",info);
	}
}
